<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>POIDocument (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="POIDocument (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":6,"i15":6,"i16":6,"i17":10,"i18":10,"i19":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIDocument.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../index-all.html">Index</a></li>
        <li><a href="../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../org/apache/poi/OldFileFormatException.html" title="class in org.apache.poi"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../org/apache/poi/POIReadOnlyDocument.html" title="class in org.apache.poi"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../index.html?org/apache/poi/POIDocument.html" target="_top">Frames</a></li>
        <li><a href="POIDocument.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi</div>
    <h2 title="Class POIDocument" class="title">Class POIDocument</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.POIDocument</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.io.Closeable, java.lang.AutoCloseable</dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../org/apache/poi/hpsf/HPSFPropertiesOnlyDocument.html"
                           title="class in org.apache.poi.hpsf">HPSFPropertiesOnlyDocument</a>, <a
                            href="../../../org/apache/poi/hslf/usermodel/HSLFSlideShowImpl.html"
                            title="class in org.apache.poi.hslf.usermodel">HSLFSlideShowImpl</a>, <a
                            href="../../../org/apache/poi/hssf/usermodel/HSSFWorkbook.html"
                            title="class in org.apache.poi.hssf.usermodel">HSSFWorkbook</a>, <a
                            href="../../../org/apache/poi/hwpf/HWPFDocumentCore.html"
                            title="class in org.apache.poi.hwpf">HWPFDocumentCore</a>, <a
                            href="../../../org/apache/poi/POIReadOnlyDocument.html" title="class in org.apache.poi">POIReadOnlyDocument</a>
                    </dd>
                </dl>
                <hr>
                <br>
                <pre>public abstract class <span class="typeNameLabel">POIDocument</span>
extends java.lang.Object
implements java.io.Closeable</pre>
                <div class="block">This holds the common functionality for all POI
                    Document classes.
                    Currently, this relates to Document Information Properties
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier</th>
                                <th class="colLast" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected </code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#POIDocument-org.apache.poi.poifs.filesystem.DirectoryNode-">POIDocument</a></span>(<a
                                        href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir)</code>
                                    <div class="block">Constructs a POIDocument with the given directory node.</div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected </code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#POIDocument-org.apache.poi.poifs.filesystem.POIFSFileSystem-">POIDocument</a></span>(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)</code>
                                    <div class="block">Constructs from the default POIFS</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#clearDirectory--">clearDirectory</a></span>()</code>
                                    <div class="block">Clear/unlink the attached directory entry</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#close--">close</a></span>()</code>
                                    <div class="block">Closes the underlying <a
                                            href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                            title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        from which
                                        the document was read, if any.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#createInformationProperties--">createInformationProperties</a></span>()</code>
                                    <div class="block">Will create whichever of SummaryInformation
                                        and DocumentSummaryInformation (HPSF) properties
                                        are not already part of your document.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getDirectory--">getDirectory</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../org/apache/poi/hpsf/DocumentSummaryInformation.html"
                                        title="class in org.apache.poi.hpsf">DocumentSummaryInformation</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getDocumentSummaryInformation--">getDocumentSummaryInformation</a></span>()</code>
                                    <div class="block">Fetch the Document Summary Information of the document</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>protected java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getEncryptedPropertyStreamName--">getEncryptedPropertyStreamName</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getEncryptionInfo--">getEncryptionInfo</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../org/apache/poi/hpsf/PropertySet.html"
                                        title="class in org.apache.poi.hpsf">PropertySet</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getPropertySet-java.lang.String-">getPropertySet</a></span>(java.lang.String&nbsp;setName)</code>
                                    <div class="block">For a given named property entry, either return it or null if
                                        if it wasn't found
                                    </div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../org/apache/poi/hpsf/PropertySet.html"
                                        title="class in org.apache.poi.hpsf">PropertySet</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getPropertySet-java.lang.String-org.apache.poi.poifs.crypt.EncryptionInfo-">getPropertySet</a></span>(java.lang.String&nbsp;setName,
                                    <a href="../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                       title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;encryptionInfo)</code>
                                    <div class="block">For a given named property entry, either return it or null if
                                        if it wasn't found
                                    </div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../org/apache/poi/hpsf/SummaryInformation.html"
                                        title="class in org.apache.poi.hpsf">SummaryInformation</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#getSummaryInformation--">getSummaryInformation</a></span>()</code>
                                    <div class="block">Fetch the Summary Information of the document</div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>protected boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#initDirectory--">initDirectory</a></span>()</code>
                                    <div class="block">check if we were created by POIFS otherwise create a new dummy
                                        POIFS
                                        for storing the package data
                                    </div>
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#readProperties--">readProperties</a></span>()</code>
                                    <div class="block">Find, and create objects for, the standard
                                        Document Information Properties (HPSF).
                                    </div>
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#replaceDirectory-org.apache.poi.poifs.filesystem.DirectoryNode-">replaceDirectory</a></span>(<a
                                        href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;newDirectory)</code>
                                    <div class="block">Replaces the attached directory, e.g.</div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#validateInPlaceWritePossible--">validateInPlaceWritePossible</a></span>()</code>
                                    <div class="block">Called during a <a
                                            href="../../../org/apache/poi/POIDocument.html#write--"><code>write()</code></a>
                                        to ensure that the Document (and
                                        associated <a
                                                href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                                title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>)
                                        was opened in a way compatible
                                        with an in-place write.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>abstract void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#write--">write</a></span>()</code>
                                    <div class="block">Writes the document out to the currently open <code>File</code>,
                                        via the
                                        writeable <a
                                                href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                                title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        it was opened from.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>abstract void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#write-java.io.File-">write</a></span>(java.io.File&nbsp;newFile)</code>
                                    <div class="block">Writes the document out to the specified new <code>File</code>.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>abstract void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#write-java.io.OutputStream-">write</a></span>(java.io.OutputStream&nbsp;out)</code>
                                    <div class="block">Writes the document out to the specified output stream.</div>
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#writeProperties--">writeProperties</a></span>()</code>
                                    <div class="block">Writes out the updated standard Document Information Properties
                                        (HPSF)
                                        into the currently open NPOIFSFileSystem
                                    </div>
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#writeProperties-org.apache.poi.poifs.filesystem.POIFSFileSystem-">writeProperties</a></span>(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;outFS)</code>
                                    <div class="block">Writes out the standard Document Information Properties (HPSF)
                                    </div>
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../org/apache/poi/POIDocument.html#writeProperties-org.apache.poi.poifs.filesystem.POIFSFileSystem-java.util.List-">writeProperties</a></span>(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;outFS,
                                    java.util.List&lt;java.lang.String&gt;&nbsp;writtenEntries)</code>
                                    <div class="block">Writes out the standard Document Information Properties (HPSF)
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="POIDocument-org.apache.poi.poifs.filesystem.DirectoryNode-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIDocument</h4>
                                <pre>protected&nbsp;POIDocument(<a
                                        href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir)</pre>
                                <div class="block">Constructs a POIDocument with the given directory node.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>dir</code> - The <a
                                            href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                            title="class in org.apache.poi.poifs.filesystem"><code>DirectoryNode</code></a>
                                        where information is read from.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="POIDocument-org.apache.poi.poifs.filesystem.POIFSFileSystem-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>POIDocument</h4>
                                <pre>protected&nbsp;POIDocument(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)</pre>
                                <div class="block">Constructs from the default POIFS</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>fs</code> - the filesystem the document is read from</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getDocumentSummaryInformation--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDocumentSummaryInformation</h4>
                                <pre>public&nbsp;<a href="../../../org/apache/poi/hpsf/DocumentSummaryInformation.html"
                                                    title="class in org.apache.poi.hpsf">DocumentSummaryInformation</a>&nbsp;getDocumentSummaryInformation()</pre>
                                <div class="block">Fetch the Document Summary Information of the document</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The Document Summary Information or null
                                        if it could not be read for this document.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getSummaryInformation--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSummaryInformation</h4>
                                <pre>public&nbsp;<a href="../../../org/apache/poi/hpsf/SummaryInformation.html"
                                                    title="class in org.apache.poi.hpsf">SummaryInformation</a>&nbsp;getSummaryInformation()</pre>
                                <div class="block">Fetch the Summary Information of the document</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The Summary information for the document or null
                                        if it could not be read for this document.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createInformationProperties--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createInformationProperties</h4>
                                <pre>public&nbsp;void&nbsp;createInformationProperties()</pre>
                                <div class="block">Will create whichever of SummaryInformation
                                    and DocumentSummaryInformation (HPSF) properties
                                    are not already part of your document.
                                    This is normally useful when creating a new
                                    document from scratch.
                                    If the information properties are already there,
                                    then nothing will happen.
                                </div>
                            </li>
                        </ul>
                        <a name="readProperties--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readProperties</h4>
                                <pre>protected&nbsp;void&nbsp;readProperties()</pre>
                                <div class="block">Find, and create objects for, the standard
                                    Document Information Properties (HPSF).
                                    If a given property set is missing or corrupt,
                                    it will remain null;
                                </div>
                            </li>
                        </ul>
                        <a name="getPropertySet-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getPropertySet</h4>
                                <pre>protected&nbsp;<a href="../../../org/apache/poi/hpsf/PropertySet.html"
                                                       title="class in org.apache.poi.hpsf">PropertySet</a>&nbsp;getPropertySet(java.lang.String&nbsp;setName)
                              throws java.io.IOException</pre>
                                <div class="block">For a given named property entry, either return it or null if
                                    if it wasn't found
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>setName</code> - The property to read</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The value of the given property or null if it wasn't found.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If retrieving properties fails</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getPropertySet-java.lang.String-org.apache.poi.poifs.crypt.EncryptionInfo-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getPropertySet</h4>
                                <pre>protected&nbsp;<a href="../../../org/apache/poi/hpsf/PropertySet.html"
                                                       title="class in org.apache.poi.hpsf">PropertySet</a>&nbsp;getPropertySet(java.lang.String&nbsp;setName,
                                     <a href="../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;encryptionInfo)
                              throws java.io.IOException</pre>
                                <div class="block">For a given named property entry, either return it or null if
                                    if it wasn't found
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>setName</code> - The property to read</dd>
                                    <dd><code>encryptionInfo</code> - the encryption descriptor in case of cryptoAPI
                                        encryption
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The value of the given property or null if it wasn't found.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If retrieving properties fails</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="writeProperties--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeProperties</h4>
                                <pre>protected&nbsp;void&nbsp;writeProperties()
                        throws java.io.IOException</pre>
                                <div class="block">Writes out the updated standard Document Information Properties
                                    (HPSF)
                                    into the currently open NPOIFSFileSystem
                                </div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if an error when writing to the open
                                        <a href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                           title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        occurs
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="writeProperties-org.apache.poi.poifs.filesystem.POIFSFileSystem-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeProperties</h4>
                                <pre>protected&nbsp;void&nbsp;writeProperties(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;outFS)
                        throws java.io.IOException</pre>
                                <div class="block">Writes out the standard Document Information Properties (HPSF)</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>outFS</code> - the POIFSFileSystem to write the properties into</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if an error when writing to the
                                        <a href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                           title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        occurs
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="writeProperties-org.apache.poi.poifs.filesystem.POIFSFileSystem-java.util.List-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeProperties</h4>
                                <pre>protected&nbsp;void&nbsp;writeProperties(<a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;outFS,
                               java.util.List&lt;java.lang.String&gt;&nbsp;writtenEntries)
                        throws java.io.IOException</pre>
                                <div class="block">Writes out the standard Document Information Properties (HPSF)</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>outFS</code> - the NPOIFSFileSystem to write the properties into</dd>
                                    <dd><code>writtenEntries</code> - a list of POIFS entries to add the property names
                                        too
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if an error when writing to the
                                        <a href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                           title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        occurs
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="validateInPlaceWritePossible--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>validateInPlaceWritePossible</h4>
                                <pre>protected&nbsp;void&nbsp;validateInPlaceWritePossible()
                                     throws java.lang.IllegalStateException</pre>
                                <div class="block">Called during a <a
                                        href="../../../org/apache/poi/POIDocument.html#write--"><code>write()</code></a>
                                    to ensure that the Document (and
                                    associated <a href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                                  title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>)
                                    was opened in a way compatible
                                    with an in-place write.
                                </div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalStateException</code> - if the document was opened
                                        suitably
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="write--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>write</h4>
                                <pre>public abstract&nbsp;void&nbsp;write()
                    throws java.io.IOException</pre>
                                <div class="block">Writes the document out to the currently open <code>File</code>, via
                                    the
                                    writeable <a href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                                 title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                    it was opened from.

                                    <p>This will fail (with an <code>IllegalStateException</code> if the
                                        document was opened read-only, opened from an <code>InputStream</code>
                                        instead of a File, or if this is not the root document. For those cases,
                                        you must use <a
                                                href="../../../org/apache/poi/POIDocument.html#write-java.io.OutputStream-"><code>write(OutputStream)</code></a>
                                        or <a href="../../../org/apache/poi/POIDocument.html#write-java.io.File-"><code>write(File)</code></a>
                                        to
                                        write to a brand new document.</div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - thrown on errors writing to the file</dd>
                                    <dd><code>java.lang.IllegalStateException</code> - if this isn't from a writable
                                        File
                                    </dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>POI 3.15 beta 3</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="write-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>write</h4>
                                <pre>public abstract&nbsp;void&nbsp;write(java.io.File&nbsp;newFile)
                    throws java.io.IOException</pre>
                                <div class="block">Writes the document out to the specified new <code>File</code>. If
                                    the file
                                    exists, it will be replaced, otherwise a new one will be created
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>newFile</code> - The new File to write to.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - thrown on errors writing to the file</dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>POI 3.15 beta 3</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="write-java.io.OutputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>write</h4>
                                <pre>public abstract&nbsp;void&nbsp;write(java.io.OutputStream&nbsp;out)
                    throws java.io.IOException</pre>
                                <div class="block">Writes the document out to the specified output stream. The
                                    stream is not closed as part of this operation.

                                    Note - if the Document was opened from a <code>File</code> rather
                                    than an <code>InputStream</code>, you <b>must</b> write out using
                                    <a href="../../../org/apache/poi/POIDocument.html#write--"><code>write()</code></a>
                                    or to a different File. Overwriting the currently
                                    open file via an OutputStream isn't possible.

                                    If <code>stream</code> is a <code>FileOutputStream</code> on a networked drive
                                    or has a high cost/latency associated with each written byte,
                                    consider wrapping the OutputStream in a <code>BufferedOutputStream</code>
                                    to improve write performance, or use <a
                                            href="../../../org/apache/poi/POIDocument.html#write--"><code>write()</code></a>
                                    / <a href="../../../org/apache/poi/POIDocument.html#write-java.io.File-"><code>write(File)</code></a>
                                    if possible.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>out</code> - The stream to write to.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - thrown on errors writing to the stream</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="close--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>close</h4>
                                <pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
                                <div class="block">Closes the underlying <a
                                        href="../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                    from which
                                    the document was read, if any. Has no effect on documents
                                    opened from an InputStream, or newly created ones.<p>

                                        Once <code>close()</code> has been called, no further operations
                                        should be called on the document.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getDirectory--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDirectory</h4>
                                <pre><a href="../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;<a href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
               title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;getDirectory()</pre>
                            </li>
                        </ul>
                        <a name="clearDirectory--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clearDirectory</h4>
                                <pre><a href="../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
protected&nbsp;void&nbsp;clearDirectory()</pre>
                                <div class="block">Clear/unlink the attached directory entry</div>
                            </li>
                        </ul>
                        <a name="initDirectory--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>initDirectory</h4>
                                <pre><a href="../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
protected&nbsp;boolean&nbsp;initDirectory()</pre>
                                <div class="block">check if we were created by POIFS otherwise create a new dummy POIFS
                                    for storing the package data
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>true</code> if dummy directory was created, <code>false</code> otherwise
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="replaceDirectory-org.apache.poi.poifs.filesystem.DirectoryNode-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>replaceDirectory</h4>
                                <pre><a href="../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
protected&nbsp;void&nbsp;replaceDirectory(<a href="../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                             title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;newDirectory)</pre>
                                <div class="block">Replaces the attached directory, e.g. if this document is written
                                    to a new POIFSFileSystem
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>newDirectory</code> - the new directory</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getEncryptedPropertyStreamName--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getEncryptedPropertyStreamName</h4>
                                <pre>protected&nbsp;java.lang.String&nbsp;getEncryptedPropertyStreamName()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the stream name of the property set collection, if the document is encrypted
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getEncryptionInfo--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getEncryptionInfo</h4>
                                <pre>public&nbsp;<a href="../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                                    title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;getEncryptionInfo()
                                 throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the encryption info if the document is encrypted, otherwise <code>null</code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If retrieving the encryption information
                                        fails
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIDocument.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../index-all.html">Index</a></li>
        <li><a href="../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../org/apache/poi/OldFileFormatException.html" title="class in org.apache.poi"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../org/apache/poi/POIReadOnlyDocument.html" title="class in org.apache.poi"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../index.html?org/apache/poi/POIDocument.html" target="_top">Frames</a></li>
        <li><a href="POIDocument.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
